<?php
class Gateway {
    private $_config;
    private $_module;
    private $_basket;

    public function __construct($module = false, $basket = false) {
        $this->_session	=& $GLOBALS['user'];
        $this->_module	= $module;
        $this->_basket =& $GLOBALS['cart']->basket;
    }  
    
    public function transfer() {
        $transfer	= array(
            'action'	=> 'https://pay.cashbill.pl/form/pay.php',
            'method'	=> 'post',
            'target'	=> '_self',
            'submit'	=> 'auto',
        );
        return $transfer;
    }
    
    public function repeatVariables() {
        return false;
    }
    
    public function fixedVariables() {
        
         $hidden = array(
        'service'=>$this->_module['user_id'],    
        'amount'=>$this->_basket['total'],
        'currency' => $GLOBALS['config']->get('config', 'default_currency'),
        'desc'=>'Zamówienie nr : '.$this->_basket['cart_order_id'],
        'lang' => '',
        'userdata'=>$this->_basket['cart_order_id'],
        'ref'=>'CubeCart',
        'forname'=> $this->_basket['billing_address']['first_name'],
        'surname'=> $this->_basket['billing_address']['last_name'],
        'email'=>$this->_basket['billing_address']['email'],
        'tel' => '',
        'street'=>$this->_basket['billing_address']['line1'],
        'street_n1' => '',
        'street_n2' => '',
        'city'=>$this->_basket['billing_address']['town'],
        'postcode'=>$this->_basket['billing_address']['postcode'],
        'country'=>$this->_basket['billing_address']['country_iso'],
        );
        
         $sign = md5(implode("|",$hidden)."|".$this->_module['user_key']);
         $hidden['sign'] = $sign;
        
        return $hidden;
    }
    

    public function form() {
        return false;
    }
    
    
    public function process() {
        httpredir(currentPage(array('_g', 'type', 'cmd', 'module'), array('_a' => 'complete')),null,true);
        return false;
    }

    public function checkSign($data, $key, $sign){
        if(md5($data['service'].$data['orderid'].$data['amount'].$data['userdata'].$data['status'].$key) === $sign){
            return true;
        }

        if(md5($data['service'].'|'.$data['orderid'].'|'.$data['amount'].'|'.$data['userdata'].'|'.$data['status'].'|'.$key) === $sign){
            return true;
        }

        return false;
    }
    
    public function call()
    { 
        
        if($this->checkSign($_POST,$this->_module['user_key'],$_POST['sign']))
        {

        $cart_order_id = sanitizeVar($_POST['userdata']);
        $order				= Order::getInstance();
        $order_summary		= $order->getSummary($cart_order_id);
        
        
        $transData['customer_id'] 	= $order_summary['customer_id'];
        $transData['gateway'] 		= 'CashBill';
        $transData['trans_id'] 		= $_POST['userdata'];
        $transData['amount'] 		= $_POST['amount'];
        
        if(strtoupper($_POST['status']) == 'OK')
        {
            $transData['status'] 	= strtoupper($_POST['status']);
            $transData['notes'] 	= 'Transakcja numer : '.$_POST['use_data'].' została opłacona na kwotę '.$_POST['amount'].' PLN';
            $order->paymentStatus(Order::PAYMENT_SUCCESS, $cart_order_id);
            $order->orderStatus(Order::ORDER_PROCESS, $cart_order_id);
            $order->logTransaction($transData);
        }    
        if(strtoupper($_POST['status']) == 'ERR')
        {
            $transData['status'] 	= strtoupper($_POST['status']);
            $transData['notes'] 	= 'Wystąpił problem z autoryzacją transakcji. Wpłata nie została przekazana.';
            $order->paymentStatus(Order::PAYMENT_CANCEL, $cart_order_id);
            $order->orderStatus(Order::ORDER_CANCELLED, $cart_order_id);
            $order->logTransaction($transData);
        }
               
        echo 'OK';
        exit();
         }
         echo 'BLAD SYGNATURY';
         exit();
    }
    
    
    
    
}